#!/usr/local/ymir/perl/bin/perl

# setting
my $maxgram = 5;
my $printper = 0.01;

##


local($/) = undef;
my $data = <>;

my $re_char = qr/[\x81-\x9f\xe0-\xef\xfa-\xfc][\x40-\x7e\x80-\xfc]| |\n/;

my @ch = map { $_ ne '' ? $_ : () } split(/($re_char)/, $data);

my @clist;
my @oldch;
my $charcount = 0;
foreach my $ch (@ch) {
  next if($ch eq '');
  if($ch eq "\n" or $ch eq ' ') {
    undef @oldch;
    next;
  }
  $charcount++;
  push(@oldch, $ch);
  shift @oldch if(scalar(@oldch) > $maxgram);
  for(my $i = scalar(@oldch) - 2; $i >= 0; $i--) {
    $clist[scalar(@oldch)-$i]{join('', @oldch[$i .. scalar(@oldch)-1])}++;
  }
}

for(my $i = 0; $i < scalar(@clist); $i++) {
  foreach my $ch (keys %{$clist[$i]}) {
    delete $clist[$i]{$ch} if($clist[$i]{$ch}/$charcount*100 < $printper);
  }
}
for(my $i = 0; $i < scalar(@clist); $i++) {
  foreach my $ch (sort {$clist[$i]{$b} <=> $clist[$i]{$a}} keys %{$clist[$i]}) {
    print "$ch: $clist[$i]{$ch} " . sprintf('(%.2f)', $clist[$i]{$ch}/$charcount*100) . "\n";
    my $key = quotemeta($ch);
    
    my @keys = grep(m/^$key/, keys %{$clist[$i+1]});
    foreach my $ch2 (sort {$clist[$i+1]{$b} <=> $clist[$i+1]{$a}} @keys) {
      print "  $ch2: $clist[$i+1]{$ch2} " . sprintf('(%.2f)', $clist[$i+1]{$ch2}/$charcount*100) . "\n";
    }
    @keys = grep(m/$key$/, keys %{$clist[$i+1]});
    foreach my $ch2 (sort {$clist[$i+1]{$b} <=> $clist[$i+1]{$a}} @keys) {
      print "  $ch2: $clist[$i+1]{$ch2} " . sprintf('(%.2f)', $clist[$i+1]{$ch2}/$charcount*100) . "\n";
    }
  }
  print "\n\n====\n\n";
}






